#include <PA9.h>

#include "fondo.h"
#include "arr.h"
#include "sonio.h"
#include "alarma.h"
#include "activao.h"


#include "song.h"



void fade_on();
void fade_off();



s8 volumen=110;
s8 i;
s8 cancion;

bool menu_son=false;
bool alarmon=false;
bool activado=false;

int main(int argc, char ** argv)
{
	PA_Init();
	PA_InitVBL();
	
	
	PA_Init16bitBg(0, 3);
	PA_Init16bitBg(1, 3);
	
	fade_on();
	PA_LoadJpeg(0,(void*)fondo);
	PA_LoadJpeg(1,(void*)arr);
	
	while(1)
	{	
		PA_CheckLid();
		PA_InitText(0,0);
		PA_InitText(1,0);
		PA_OutputText(0,0,3,"%d/%d/%d",PA_RTC.Day,PA_RTC.Month,PA_RTC.Year);
		PA_OutputText(0,24,3,"%d:%d:%d",PA_RTC.Hour,PA_RTC.Minutes,PA_RTC.Seconds);
		
		if(alarmon==true){
				PA_OutputText(0,11,10,"%d",PA_UserInfo.AlarmHour);
				PA_OutputText(0,11,17,"%d",PA_UserInfo.AlarmMinute);
				
				if(Stylus.Newpress && Stylus.X>135 && Stylus.X<150 && Stylus.Y>72 && Stylus.Y<86){
					PA_UserInfo.AlarmHour++;
				}
				if(Stylus.Newpress && Stylus.X>162 && Stylus.X<176 && Stylus.Y>72 && Stylus.Y<86){
					PA_UserInfo.AlarmHour--;
					
				}
				
				if(PA_UserInfo.AlarmHour>=24) PA_UserInfo.AlarmHour=0;
				
				if(Stylus.Newpress && Stylus.X>135 && Stylus.X<150 && Stylus.Y>131 && Stylus.Y<147){
					PA_UserInfo.AlarmMinute++;
				}
				if(Stylus.Newpress && Stylus.X>163 && Stylus.X<176 && Stylus.Y>131 && Stylus.Y<146){
					PA_UserInfo.AlarmMinute--;
					
				}
				
				if(PA_UserInfo.AlarmMinute>=60) PA_UserInfo.AlarmMinute=0;
		}
		
		if(Stylus.Newpress && Stylus.X>75 && Stylus.X<150 && Stylus.Y>0 && Stylus.Y<26){
			fade_off();
			menu_son=true;
			alarmon=false;
			activado=false;
			PA_LoadJpeg(0,(void*)sonio);
			fade_on();
			
			
		}
		
		if(Stylus.Newpress && Stylus.X>0 && Stylus.X<149 && Stylus.Y>0 && Stylus.Y<26){
			alarmon=true;
			menu_son=false;
			activado=false;
			fade_off();
			PA_LoadJpeg(0,(void*)alarma);
			fade_on();
			

		}
		
		if(Stylus.Newpress && Stylus.X>152 && Stylus.X<228 && Stylus.Y>0 && Stylus.Y<26){
			activado=true;
			fade_off();
			alarmon=false;
			menu_son=false;
			PA_LoadJpeg(0,(void*)activao);
			fade_on();
			
		}
		
		if(menu_son==true){	
			if(Stylus.Newpress && Stylus.X>23 && Stylus.X<234 && Stylus.Y>41 && Stylus.Y<70){
				cancion=0;
			}
			if(Stylus.Newpress && Stylus.X>23 && Stylus.X<234 && Stylus.Y>42 && Stylus.Y<95){
				cancion=1;
			}
		}
		
		if(activado==true){
					u16 power_cr;
			PA_OutputText(0,13,11,"%d:%d",PA_UserInfo.AlarmHour,PA_UserInfo.AlarmMinute);
			if(Stylus.Newpress && Stylus.X>157 && Stylus.X<231 && Stylus.Y>148 && Stylus.Y<178){
				powerOFF(15);
			}
			
			if(PA_RTC.Hour==PA_UserInfo.AlarmHour && PA_RTC.Minutes==PA_UserInfo.AlarmMinute){
				powerON(15)
				PA_InitSound();
				if(cancion==0) PA_PlaySound(0,(void*)song,(u32)song_size,120,22050);
				
				
				
			}
		}

		PA_WaitForVBL();
	}
	return 0;
}

void fade_off()
{
	for(i=0; i<=31; i++){
		PA_SetBrightness(0, i);
		//PA_SetBrightness(1, i);
		PA_WaitForVBL();
	}
}
void fade_on()
{
	for(i=31; i>=0; i--){
		PA_SetBrightness(0, i);
		//PA_SetBrightness(1, i);
		PA_WaitForVBL();
	}
}
